<?php get_header(); ?>
<div class="content-layout">
    <div class="content-layout-row">
        <div class="layout-cell content">
			<?php 
				get_sidebar('top'); 
				global $post;
				if (have_posts()){

					the_post();
						
					if (!empty( $post->post_parent ) ) {
						$return_link = '<a href="'. get_permalink( $post->post_parent ) .'" title="'.esc_attr(sprintf( __('Return to %s', THEME_NS), get_the_title($post->post_parent))) .'" rel="gallery">'
							.sprintf( __( '<span class="meta-nav">&larr;</span> %s', THEME_NS ), get_the_title( $post->post_parent ) ) . '</a>';
						cvi_page_navigation(array('next_link' => $return_link));
					}
					
					ob_start();
					if ( wp_attachment_is_image() ) {
						$attachments = array_values(get_children(array( 'post_parent' => $post->post_parent, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => 'ASC', 'orderby' => 'menu_order ID')));
						foreach ( $attachments as $k => $attachment ) {
							if ( $attachment->ID == $post->ID )
								break;
						}
						$k++;
						$next_attachment_url = '';
						// If there is more than 1 image attachment in a gallery
						if ( count( $attachments ) > 1 ) {
							if ( isset( $attachments[ $k ] ) )
								// get the URL of the next image attachment
								$next_attachment_url = get_attachment_link( $attachments[ $k ]->ID );
							else
								// or get the URL of the first image attachment
								$next_attachment_url = get_attachment_link( $attachments[ 0 ]->ID );
						} else {
							// or, if there's only 1 image attachment, get the URL of the image
							$next_attachment_url = wp_get_attachment_url();
						}
						
						?>
						<p class="attachment center">
							<a href="<?php echo $next_attachment_url; ?>" title="<?php echo esc_attr( get_the_title() ); ?>" rel="attachment">
								<?php
								$attachment_size = apply_filters( 'attachment_size', 600 );
								echo wp_get_attachment_image( $post->ID, array( $attachment_size, 9999 ) ); // filterable image width with, essentially, no limit for image height.
								?>
							</a>
						</p>
						<?php	
					} else {
						?>
							<p class="attachment center">
								<a href="<?php echo wp_get_attachment_url(); ?>" title="<?php echo esc_attr( get_the_title() ); ?>" rel="attachment">
									<?php echo basename( get_permalink() ); ?>
								</a>
							</p>
						<?php	
					}	
				
					echo cvi_get_content();
				
					if ( wp_attachment_is_image() ) {
								$metadata = wp_get_attachment_metadata();
								echo '<p class="center">' . sprintf( __( 'Full size is %s pixels', THEME_NS),
									sprintf( '<a href="%1$s" title="%2$s">%3$s &times; %4$s</a>',
										wp_get_attachment_url(),
										esc_attr( __('Link to full-size image', THEME_NS) ),
										$metadata['width'],
										$metadata['height']
									)
								) . '</p>';
					}
					
					cvi_page_navigation(array('wrap' => false, 'prev_link' => cvi_get_next_image_link(false), 'next_link' => cvi_get_previous_image_link(false)));
					
					cvi_post_wrapper(
						array(
								'id' => cvi_get_post_id(), 
								'class' => cvi_get_post_class(),
								'title' => '<a href="'.get_permalink($post->ID).'" rel="bookmark" title="'.get_the_title().'">'.get_the_title().'</a>', 
								'before' => cvi_get_metadata_icons('date,author,edit', 'header'),
								'content' =>ob_get_clean(),
						)
					);
					
					comments_template();
					
					

				} else {
					cvi_404_content();
				}

			  get_sidebar('bottom'); 
			?>
          <div class="cleared"></div>
        </div>
    </div>
</div>
<div class="cleared"></div>
<?php get_footer();