<?php

function cvi_print_options() {
	global $cvi_options;
?>
<div class="wrap">
	<div id="icon-themes" class="icon32"><br></div>
	<h2><?php _e('Theme Options'); ?></h2>
<?php 
	if ( isset($_REQUEST['Submit']) )	{ 
		foreach ($cvi_options as $value) {
			$id = cvi_get_array_value($value, 'id');
			$val = stripslashes(cvi_get_array_value($_REQUEST, $id));
			$type = cvi_get_array_value($value, 'type');
			switch($type){
				case 'checkbox':
					$val = ($val  ? 1 : 0);
				break;
				case 'numeric':
					$val = (int) $val;
				break;
			}
			update_option( $id, $val); 
		}
		echo '<div id="message" class="updated fade"><p><strong>'. __('Settings saved.') .'</strong></p></div>'.BR; 
	} 
	if ( isset($_REQUEST['Reset']) )	{ 
	foreach ($cvi_options as $value) {
		delete_option(cvi_get_array_value($value, 'id')); 
	}
	echo '<div id="message" class="updated fade"><p><strong>'. __('Settings restored.') . '</strong></p></div>'.BR;
	} 
	echo '<form method="post">'.BR;
	$in_form_table = false;
	foreach ($cvi_options as $op) {
		$type = cvi_get_array_value($op, 'type');
		$name = cvi_get_array_value($op, 'name');
		$desc = cvi_get_array_value($op, 'desc');
		if ($type == 'heading'){
			if ($in_form_table) {
				echo '</table>'.BR;
				$in_form_table = false;
			}
			echo '<h3>'.$name.'</h3>'.BR;
			if ($desc) {
				echo BR.'<p class="description">'.$desc.'</p>'.BR;
			}
		} else {
			if (!$in_form_table) {
				echo '<table class="form-table">'.BR;
				$in_form_table = true;
			}
			echo '<tr valign="top">'.BR;
			echo '<th scope="row">'.$name.'</th>'.BR;
			echo '<td>'.BR;
			$id = cvi_get_array_value($op, 'id');
			$val = cvi_get_option($id);
			cvi_print_option_control($op, $val);
			if ($desc) {
			echo '<span class="description">'.$desc.'</span>'.BR;
			}
			echo '</td>'.BR;
			echo '</tr>'.BR;
		}
	}
	if ($in_form_table) {
	echo '</table>'.BR;
	}
?>
	<p class="submit">
		<input name="Submit" type="submit" class="button-primary" value="<?php echo esc_attr(__('Save Changes')) ?>" />
		<input name="Reset" type="submit" class="button-secondary" value="<?php echo esc_attr(__('Reset to Default')) ?>" />
	</p>
	</form>
	</div>
<?php
}


function cvi_print_option_control($op, $val){
	$id = cvi_get_array_value($op, 'id');
	$type = cvi_get_array_value($op, 'type');
	$options = cvi_get_array_value($op, 'options');
	switch ( $type) {
		case 'numeric':
		echo '<input	name="'.$id.'" id="'.$id.'" type="text" value="'.absint($val).'" class="small-text" />'.BR;
		break;
		case 'select':
		echo '<select name="'.$id.'" id="'.$id.'">'.BR;
			foreach ($op['options'] as $key	=>	$option) { 
				$selected = ($val == $key ? ' selected="selected"' : '');
				echo '<option'.$selected.' value="'.$key.'">'.esc_html(__($option)).'</option>'.BR; 
			}
		echo '</select>'.BR;
		break;
		case 'textarea':
		echo '<textarea name="'.$id.'" id="'.$id.'" rows="10" cols="50" class="large-text code">'.esc_html($val).'</textarea><br />'.BR;
		break;
		case "radio":
			foreach ($op['options'] as $key=>$option) {
				$checked = ( $key == $val ? 'checked="checked"' : '');
				echo '<input type="radio" name="'.$id.'" id="'.$id.'" value="'.esc_attr($key).'" '.$checked.'/>'.esc_html($option).'<br />'.BR;
			}
		break;
		case "checkbox":
			$checked =	($val ? 'checked="checked" ' : ''); 
			echo '<input type="checkbox" name="'.$id.'" id="'.$id.'" value="1" '.$checked.'/>'.BR;
		break;
		default:
		$class = 'regular-text';
		if ($type == 'numeric'){
			$type = 'text';
			$class = 'small-text';
			$val = absint($val);
		}
		if ($type == 'widetext') {
			$class = 'large-text';
		}
		echo '<input	name="'.$id.'" id="'.$id.'" type="'.$type.'" value="'.esc_attr($val).'" class="'.$class.'" />'.BR;
		break;
	}
}

// Not support old wp version
if (WP_VERSION < 3.0) return;
 


function cvi_add_meta_boxes() {
    add_meta_box( 'cvi_meta_box',
                  __('Theme Options', THEME_NS),
                  'cvi_print_page_meta_box',
                  'page',
                  'side',
                  'low'
                 );
    add_meta_box( 'cvi_meta_box',
                  __('Theme Options', THEME_NS),
                  'cvi_print_post_meta_box',
                  'post',
                  'side',
                  'low'
                 );
}

/* Prints meta box content */
function cvi_print_page_meta_box($post) {
	global $cvi_page_meta_options;
	cvi_print_meta_box($post, $cvi_page_meta_options);
}

function cvi_print_post_meta_box($post) {
	global $cvi_post_meta_options;
	cvi_print_meta_box($post, $cvi_post_meta_options);
}

function cvi_print_meta_box($post, $meta_options) {
    // Use nonce for verification
    wp_nonce_field('cvi_meta_options', 'cvi_meta_noncename');
	if (!isset($post)) return;
	foreach ($meta_options as $option) {
		$id = cvi_get_array_value($option, 'id');
		$name = cvi_get_array_value($option, 'name');
		$desc = cvi_get_array_value($option, 'desc');
		$value = cvi_get_meta_option($post->ID, $id);
		$necessary = cvi_get_array_value($option, 'necessary');
		if ($necessary && !current_user_can($necessary)) continue;
        echo '<p class="meta-options"><label class="selectit" for="'.$id.'"><strong>'.$name .'</strong></label><br />';
		cvi_print_option_control($option, $value);
		if ($desc) {
			echo '<em>'.$desc.'</em>';
		}
		echo'</p>';
    }
}



// post metadata
/* When the post is saved, saves our data */
function cvi_save_post($post_id) {
	global $cvi_post_meta_options, $cvi_page_meta_options;
    // verify this came from the our screen and with proper authorization,
    // because save_post can be triggered at other times

    if (!isset($_POST['cvi_meta_noncename']) || !wp_verify_nonce($_POST['cvi_meta_noncename'], 'cvi_meta_options' )) {
        return $post_id;
    }

    // verify if this is an auto save routine. If it is our form has not been submitted, so we dont want
    // to do anything
    if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
        return $post_id;
	
	$meta_options = null;//posts
	if ( 'page' == $_POST['post_type']) {
		// Check permissions
		if (!current_user_can( 'edit_page', $post_id ) ){
			return $post_id;
		}
		$meta_options = $cvi_page_meta_options;
	}
	
	if ( 'post' == $_POST['post_type']) {
		$meta_options = $cvi_post_meta_options;
	}
	
	if (!$meta_options) return $post_id;
	// OK, we're authenticated: we need to find and save the data
	foreach ($meta_options as $value) {
		$id = cvi_get_array_value($value, 'id');
		$val = stripslashes(cvi_get_array_value($_REQUEST, $id));
		$type = cvi_get_array_value($value, 'type');
		$necessary = cvi_get_array_value($value, 'necessary');
		if ($necessary && !current_user_can($necessary)) continue;
		switch($type){
			case 'checkbox':
				$val = ($val  ? 1 : 0);
			break;
			case 'numeric':
				$val = (int) $val;
			break;
		}
		cvi_set_meta_option($post_id, $id, $val); 
	}
	return $post_id;
}